This file seeks to describe the working of the project Makefile.
We don't specify dependencies in the same way as we would with gcc as we don't build each individual sourcefile to a .o file. Instead we build individual modules to a .o file. However we cheat a little by the fact that when we specify bar.foo.package we actually build bar.foo.package.o from bar.foo.package.* as we recurse down the directory tree.
We have a BASE_PACKAGE in the make file which specifys where our main code is, packages below this direcotry are built independently and not recursivly as described in the previous paragraph.
We automatically generate dep files by using find and then including them, using the Makefile auto-rebuild feature unique to the GNU version of Make. We have the following extensions:
	.dep	Specifying dependencies from packages below the BASE_PACKAGE
	.mdep	Specifying dependencies for packages outside of the BASE_PACKAGE
	.fdep	Specifying dependencies generated from a specifc file
These extensions are more an artifact of pattern rules being differnt than anything else, however it is probably useful for debuggin.
The idea behind the variables in the makefile is that you only need to specify something once, and it is then rewritten [often several times] whenever its needed in a slightly differnt form.
Due to the version of make on kern being less than 3.80 we don't have the | extensions to prerequisites, so we use .foo files instead to store if the directories have been created, this means we don't rebuild packages everytime as it thinks the prerequisites [eg the BIN_DIR] have changed, when in fact its only had another file palced in it from another build.
We also have several clean targets to do differnt things, ie so we don't have to regen javadoc every time if we don't want to.
The alst section contains utility targets for doing random things, like counting the number of lines in the code.

The Makefile builds everything into .o files depending which module it belongs to, for almost all modules this means that we just compile the org.ucam.srcf.assassins.foo* package to foo.o, and any non autoumpire package to its fully qualified lcassname.o. Merely adding the package name to the obvious variable in the Makefile should be sufficent for it to be autmatically hooked into the dependency generation and compilation rules. If your module consists of more than one package tree below org.ucam.srcf.assassins then you have two options, either write a custom rule [see vanilla.o's rule] or just add all the relevant packages to the MODULES variable to compile them to sepearte .o files, which I'd consider more of a hack, and could cause compile problems if they rely on each other.

In order to avoid bloat of copmiling everything into all the binaries, we use shared libraries, however  if you're just writing plugins you don't have to worry about this (unless you want to use an external library, like Strawberry does)

Top level targets you may want to build from the Makefile:
bin/yourmod.o	-	builds yourmod.o - note the bin/ is required
autoumpire		-	builds the autoumpire CLI executable
umpire.cgi		-	builds the autoumpire CGI executable
doc				-	runs javadoc for the (entire) project
cleandoc			-	cleans out the javadoc directory
clean				-	cleans out executable and object files
distclean		-	does clean, cleandoc and a few others to restore
							(in theory) the project to whats in the CVS
count				-	Provides a quick and hacky wordcount of all
							java files in the org.ucam.srcf.assassins.*
							packages
htmldoc			-	runs the man apges through a man2html type command
							and places the results in doc/html/$(lang)/manpages
doc				-	makes the javadoc from the source
deploy			-	Installs into place set by the enviroment vars:
								Env Var:					What:					Default:
							INSTALL_DIR 			see fileHierarcy 		deploy
